stages:
  - build
  - test
  - security
  - deploy

image: node:17

include:
  - template: Security/SAST.gitlab-ci.yml

# overwrite SAST job stage and start job as soon as pipeline begins
sast:
  stage: security
  needs: []


# Cache modules in between jobs
cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
  - node_modules/

 
build_app:
  stage: build
  before_script:
    - export NODE_OPTIONS=--openssl-legacy-provider
  script:
    - yarn install
    - yarn upgrade
    - yarn run build
    - yarn cache clean

unit_test:
  stage: test
  before_script:
    - yarn add chai mocha mocha-simple-html-reporter mocha-junit-reporter chai-http mocha-test-url

  script:
    - ./node_modules/mocha/bin/_mocha "test/*.js" --reporter mocha-junit-reporter --reporter-options mochaFile=./testresults/test-results.xml
    - ./node_modules/mocha/bin/_mocha "test/*.js" --reporter mocha-simple-html-reporter --reporter-options output=./testresults/test-results.html
    
  after_script:
    - echo "build_app job has run!"

code_quality:
  stage: test
  script:
    -  echo "This will run code quality in the future"
    -  exit 1
  ### This job can run independently of any previous job completion, i.e. build job, in order to execute
  needs: []
  rules:
    - if: $CI_COMMIT_BRANCH == 'main'
      allow_failure: true


build_a:
 stage: build
 script:
  - echo "build_a"

build_b:
 stage: build
 script:
  - echo "build_b"

build_c:
 stage: build
 script:
  - echo "build_c"

build_d:
 stage: build
 script:
  - echo "build_d"

build_e:
 stage: build
 script:
  - echo "build_e"

build_f:
 stage: build
 script:
  - echo "build_f"

test_a:
 stage: test
 needs: [build_a]
 script:
  - echo "test_a"

test_b:
 stage: test
 needs: [build_b]
 script:
  - echo "test_b"

test_c:
 stage: test
 needs: [build_c]
 script:
  - echo "test_c"

test_d:
 stage: test
 needs: [build_d]
 script:
  - echo "test_d"

test_e:
 stage: test
 needs: [build_e]
 script:
  - echo "test_e"

test_f:
 stage: test
 needs: [build_f]
 script:
  - echo "test_f"

deploy_a:
 stage: deploy
 needs: [test_a]
 script:
  - echo "deploy_a"

deploy_b:
 stage: deploy
 needs: [test_b]
 script:
  - echo "deploy_b"

deploy_c:
 stage: deploy
 needs: [test_c]
 script:
  - echo "deploy_c"

deploy_d:
 stage: deploy
 needs: [test_d]
 script:
  - echo "deploy_d"

deploy_e:
 stage: deploy
 needs: [test_e]
 script:
  - echo "deploy_e"

deploy_f:
 stage: deploy
 needs: [test_f]
 script:
  - echo "deploy_f"


